/* Test of assembly code branches */
#include "mips.h"
#include "gen_code.h"

code_word code[] = {
{ADDIU_INSTR(1,0,3), "addiu $1,$0,3"},
{NOP_INSTR, "nop"},
{NOP_INSTR, "nop"},
/* Should fall through this one */
{BEQ_INSTR(0,1,4), "beq $0,$1,PC+16"},
{ADDIU_INSTR(2,0,1), "addiu $2,$0,1"},
{ADDIU_INSTR(2,0,2), "addiu $2,$0,2"},
{ADDIU_INSTR(2,0,3), "addiu $2,$0,3"},
{ADDIU_INSTR(2,0,4), "addiu $2,$0,4"},
/* Should take this one */
{BNE_INSTR(0,1,4), "bne $0,$1,PC+16"},
{ADDIU_INSTR(3,0,1), "addiu $3,$0,1"},
{ADDIU_INSTR(3,0,2), "addiu $3,$0,2"},
{ADDIU_INSTR(3,0,3), "addiu $3,$0,3"},
{ADDIU_INSTR(3,0,4), "addiu $3,$0,4"},
{ADDIU_INSTR(4,0,1), "addiu $4,$0,1"}, 
/* Should take this one too */
{BEQ_INSTR(4,4,2), "beq $4,$4,PC+8"},
{ADDIU_INSTR(4,4,3), "addiu $4,$4,3 --> 4"},
/* Should skip this */  
{BREAK_INSTR(0), "break"}, 
/* Branch target */
{ADDIU_INSTR(4,4,2), "addiu $4,$4,2 --> 6"},
END_INSTR
};

