/* Test of assembly code data instructions */
#include "mips.h"
#include "gen_code.h"

code_word code[] = {
/* Basic operations */
{ADDIU_INSTR(1,0,3), "addiu $1,$0,3"},
{ADDIU_INSTR(2,0,5),  "addiu $2,$0,5"},  
{NOP_INSTR, "nop"},
{NOP_INSTR, "nop"},
{NOR_INSTR(3,1,2), "nor $3,$1,$2 --> fffffff8"},
{OR_INSTR(4,1,2), "or $4,$1,$2 --> 7"},
{SLT_INSTR(5,1,2), "slt $5,$1,$2 --> 1"},
{SLTU_INSTR(6,2,1), "sltu $6,$2,$1 --> 0"},
{SUBU_INSTR(7,2,1), "subu $7,$2,$1 --> 2"},
/* Hazard tests */
{ADDIU_INSTR(8,0,3), "addiu $8,$0,3 --> 3"},
{ADDIU_INSTR(8,0,2), "addiu $8,$0,2 --> 2"},
{ADDIU_INSTR(8,0,1), "addiu $8,$0,1 --> 1"},
{ADDU_INSTR(9,0,8), "addu $9,$0,$8   --> 1"},
{ADDU_INSTR(10,9,0), "addu $10,$9,0 -->1"},
{ADDIU_INSTR(8,0,6), "addiu $8,$0,6 --> 6"},
{NOP_INSTR, "nop"}, 
{ADDU_INSTR(11,8,0), "addu $11,$8,$0 --> 6"},
{ADDIU_INSTR(8,0,5), "addiu $8,$0,5 --> 5"},
{NOP_INSTR, "nop"}, 
{ADDU_INSTR(12,0,8), "addu $12,$0,$8 --> 5"},
{ADDIU_INSTR(13,0,28), "addiu $13,$0,28 --> 28"},
{ADDIU_INSTR(14,0,24), "addiu $14,$0,24 --> 24"},
{NOP_INSTR, "nop"},
{NOP_INSTR, "nop"},
{SW_INSTR(13,0,14), "sw $13,0($14) --> 28"},
{LW_INSTR(15,-4,13), "lw $15,-4($13) --> 28"},
{SW_INSTR(15,0,13), "sw $15,0($13) --> 28"},
{LW_INSTR(16,0,13), "lw $16,0($13) --> 28"},
{ADDIU_INSTR(17,16,4), "addiu $17,$16,4 --> 32"},
{SW_INSTR(17,4,13), "sw $17,4($13) --> 32"},
{LW_INSTR(18,4,13), "lw $18,4($13) --> 32"},
{ADDIU_INSTR(13,13,8), "addiu $13,$13,8 --> 36"},
{LW_INSTR(19,-4,13), "lw $19,-4($13) --> 32"},
{ADDIU_INSTR(13,13,8), "addiu $13,$13,8 --> 44"},
{NOP_INSTR, "nop"},
{SW_INSTR(13,0,14), "sw $13,0($4) --> 44"},
{LW_INSTR(20,0,14), "lw $20,0($4) --> 44"},
END_INSTR
};

