/* Test of assembly code jumps */
#include "mips.h"
#include "gen_code.h"

code_word code[] = {
{ADDIU_INSTR(1,0,28), "0: addiu $1,$0,28 --> 28"},
{JALR_INSTR(1), "4:jalr $1 (to 20)"},
/* Delay slot */
{ADDIU_INSTR(2,31,0), "8: addiu $2,$31,0 --> 8"},
/* Return point */
{ADDIU_INSTR(3,3,4), "[rtn tgt]12: addiu $3,$3,4 --> 4"},
{J_INSTR(11), "16:j 4*11"},
/* Delay slot */
{ADDIU_INSTR(3,3,3), "20: addiu $3,$3,3 --> 7"},
/* Shouldn't hit this */
{BREAK_INSTR(0), "24: break skipped"},
/* Procedure target */
{ADDIU_INSTR(4,0,1), "[jalr tgt]28: addiu $4,$0,1 --> 1"},
{JR_INSTR(31), "32: jr $31"},
/* Delay slot */
{ADDIU_INSTR(4,4,2), "36: addiu $4,$4,2 --> 3"},
/* Shouldn't hit this */
{BREAK_INSTR(0), "40: break skipped"},   
/* Jump target */
{ADDIU_INSTR(4,4,4), "[j tgt]44: addiu $4,$4,4 --> 7"},
END_INSTR
};

